#include "lcd.h"
#include "debug.h"
#include "lcd_init.h"
#include "lcdfont.h"
#include "spi.h"
//#include "dma.h"

extern u8 TxData[IMAGE_W * 10 * 2];

/**
 * @fn void LCD_Fill(u16 xsta,u16 ysta,u16 xend,u16 yend,u16 color)
 * @brief ָɫ
 * @param xsta xʼ
 * @param ysta yʼ
 * @param xend yֹ
 * @param yend yֹ
 * @param color Ҫɫ
 * @return none
 */
void LCD_Fill(u16 xsta, u16 ysta, u16 xend, u16 yend, u16 color)
{
   unsigned int i, m;
   LCD_Address_Set(SPI1, xsta, ysta, xend - 1, yend - 1);
   LCD_WriteIndex(SPI1, 0x2C);
   for(i = 0; i < xend; i++) {
       for(m = 0; m < yend; m++) {
           LCD_WriteHalfWord(SPI1, color);
       }
    }
}

/**
 * @fn void LCD_SetXY(u16 x,u16 y)
 * @brief LCDʾʼ
 * @param x xʼ
 * @param y yʼ
 * @return none
 */
void LCD_SetXY(u16 x,u16 y)
{
    LCD_Address_Set(SPI1, x,y,x,y);
}

/**
 * @fn
 * @brief ָɫ
 * @param x x
 * @param y y
 * @param color ɫ
 * @return none
 */
void LCD_DrawPoint(u16 x, u16 y, u16 color)
{
	LCD_Address_Set(SPI1, x,y,x,y);//ùλ
	LCD_WriteHalfWord(SPI1, color);
} 

/**
 * @fn void LCD_DrawLine(u16 x1,u16 y1,u16 x2,u16 y2,u16 color)
 * @brief ָɫ
 * @param x1 xʼ
 * @param y1 yʼ
 * @param x2 yֹ
 * @param y2 yֹ
 * @param color ɫ
 * @return none
 */
void LCD_DrawLine(u16 x1,u16 y1,u16 x2,u16 y2,u16 color)
{
	u16 t; 
	int xerr=0, yerr=0, delta_x, delta_y, distance;
	int incx, incy, uRow, uCol;

	delta_x = x2-x1; //
	delta_y = y2-y1;
	uRow = x1;//
	uCol = y1;
	if(delta_x > 0)
	    incx = 1; //õ
	else if(delta_x == 0)
	    incx = 0;//ֱ
	else {
	    incx = -1;
	    delta_x = -delta_x;
	}
	if(delta_y > 0)
	    incy = 1;
	else if (delta_y == 0)
	    incy = 0;//ˮƽ
	else {
	    incy = -1;
	    delta_y = -delta_y;
	}
	if(delta_x > delta_y)
	    distance = delta_x; //ѡȡ
	else
	    distance = delta_y;
	for(t=0; t < distance + 1; t++) {
		LCD_DrawPoint(uRow, uCol, color);//
		xerr += delta_x;
		yerr += delta_y;
		if(xerr > distance) {
			xerr -= distance;
			uRow += incx;
		}
		if(yerr > distance) {
			yerr -= distance;
			uCol += incy;
		}
	}
}

/**
 * @fn void DisplayButtonDown(u16 x1,u16 y1,u16 x2,u16 y2)
 * @brief ָɫ
 * @param x1 xʼ
 * @param y1 yʼ
 * @param x2 yֹ
 * @param y2 yֹ
 * @return none
 */
void DisplayButtonDown(u16 x1,u16 y1,u16 x2,u16 y2)
{
    LCD_DrawLine(x1, y1, x2,y1, GRAY2);  //H
    LCD_DrawLine(x1+1,y1+1,x2,y1+1, GRAY1);  //H
    LCD_DrawLine(x1, y1, x1,y2, GRAY2);  //V
    LCD_DrawLine(x1+1,y1+1,x1+1,y2, GRAY1);  //V
    LCD_DrawLine(x1, y2, x2,y2, WHITE);  //H
    LCD_DrawLine(x2, y1, x2,y2, WHITE);  //V
}

/**
 * @fn void DisplayButtonUp(u16 x1,u16 y1,u16 x2,u16 y2)
 * @brief Ļʾһµİť
 * @param x1 xʼ
 * @param y1 yʼ
 * @param x2 yֹ
 * @param y2 yֹ
 * @return none
 */
void DisplayButtonUp(u16 x1,u16 y1,u16 x2,u16 y2)
{
    LCD_DrawLine(x1, y1, x2,y1, WHITE); //H
    LCD_DrawLine(x1, y1, x1,y2, WHITE); //V

    LCD_DrawLine(x1+1,y2-1,x2,y2-1, GRAY1);  //H
    LCD_DrawLine(x1, y2, x2,y2, GRAY2);  //H
    LCD_DrawLine(x2-1,y1+1,x2-1,y2, GRAY1);  //V
    LCD_DrawLine(x2 ,y1 ,x2,y2, GRAY2); //V
}
/**
 * @fn void LCD_DrawRectangle(u16 x1, u16 y1, u16 x2, u16 y2,u16 color)
 * @brief 
 * @param x1 xʼ
 * @param y1 yʼ
 * @param x2 yֹ
 * @param y2 yֹ
 * @param color ɫ
 * @return none
 */
void LCD_DrawRectangle(u16 x1, u16 y1, u16 x2, u16 y2,u16 color)
{
	LCD_DrawLine(x1, y1, x2, y1, color);
	LCD_DrawLine(x1, y1, x1, y2, color);
	LCD_DrawLine(x1, y2, x2, y2, color);
	LCD_DrawLine(x2, y1, x2, y2, color);
}

/**
 * @fn void Draw_Circle(u16 x0,u16 y0,u8 r,u16 color)
 * @brief ָɫ
 * @param x0 Բx
 * @param y0 Բy
 * @param r       뾶
 * @param color   Բɫ
 * @return none
 */
void Draw_Circle(u16 x0, u16 y0, u8 r, u16 color)
{
	int a,b;
	a=0;b=r;	  
	while(a<=b) {
		LCD_DrawPoint(x0 - b, y0 - a, color);             //3
		LCD_DrawPoint(x0 + b, y0 - a, color);             //0
		LCD_DrawPoint(x0 - a, y0 + b, color);             //1
		LCD_DrawPoint(x0 - a, y0 - b, color);             //2
		LCD_DrawPoint(x0 + b, y0 + a, color);             //4
		LCD_DrawPoint(x0 + a, y0 - b, color);             //5
		LCD_DrawPoint(x0 + a, y0 + b, color);             //6
		LCD_DrawPoint(x0 - b, y0 + a, color);             //7
		a++;
		if((a * a + b * b) > (r * r)) {//жҪĵǷԶ
			b--;
		}
	}
}

/**
 * @fn void LCD_ShowChinese(u16 x,u16 y,u8 *s,u16 fc,u16 bc,u8 sizey,u8 mode)
 * @brief ʾִ
 * @param x xʼ
 * @param y yʼ
 * @param *s Ҫʾĺִ
 * @param fc ֵɫ
 * @param bc ֵıɫ
 * @param sizey ֺ ѡ 16 24 32
 * @param mode:  0ǵģʽ  1ģʽ
 * @return none
 */
void LCD_ShowChinese(u16 x, u16 y, u8 *s, u16 fc, u16 bc, u8 sizey, u8 mode)
{
	while(*s != 0) {
		if(sizey == 12)
		    LCD_ShowChinese12x12(x, y, s, fc, bc, sizey, mode);
		else if(sizey == 16)
		    LCD_ShowChinese16x16(x, y, s, fc, bc, sizey, mode);
		else if(sizey == 24)
		    LCD_ShowChinese24x24(x, y, s, fc, bc, sizey, mode);
		else if(sizey == 32)
		    LCD_ShowChinese32x32(x, y, s, fc, bc, sizey, mode);
		else
		    return;
		s += 2;
		x += sizey;
	}
}

/**
 * @fn void LCD_ShowChinese12x12(u16 x,u16 y,u8 *s,u16 fc,u16 bc,u8 sizey,u8 mode)
 * @brief ʾ12x12
 * @param x xʼ
 * @param y yʼ
 * @param *s Ҫʾĺ
 * @param fc ֵɫ
 * @param bc ֵıɫ
 * @param sizey ֺ
 * @param mode:  0ǵģʽ  1ģʽ
 * @return none
 */
void LCD_ShowChinese12x12(u16 x, u16 y, u8 *s, u16 fc, u16 bc, u8 sizey, u8 mode)
{
	u8 i, j, m=0;
	u16 k;
	u16 HZnum;//Ŀ
	u16 TypefaceNum;//һַռֽڴС
	u16 x0 = x;
	TypefaceNum = (sizey / 8 + ((sizey % 8) ? 1 : 0)) * sizey;
	                         
	HZnum = sizeof(tfont12) / sizeof(typFNT_GB12);	//ͳƺĿ
	for(k = 0; k < HZnum; k++) {
		if((tfont12[k].Index[0] == *(s)) && (tfont12[k].Index[1] == *(s+1))) { 	
			LCD_Address_Set(SPI1, x, y, x + sizey - 1, y + sizey - 1);
			for(i = 0; i < TypefaceNum; i++) {
				for(j = 0; j < 8; j++) {	
					if(!mode) {//ǵӷʽ
						if(tfont12[k].Msk[i] & (0x01 << j))
						    LCD_WriteHalfWord(SPI1, fc);
						else
						    LCD_WriteHalfWord(SPI1, bc);
						m++;
						if(m % sizey == 0) {
							m = 0;
							break;
						}
					}
					else {//ӷʽ
						if(tfont12[k].Msk[i] & (0x01 << j))
						    LCD_DrawPoint(x, y, fc);//һ
						x++;
						if((x - x0) == sizey) {
							x = x0;
							y++;
							break;
						}
					}
				}
			}
		}				  	
		continue;  //ҵӦֿ˳ֹظȡģӰ
	}
} 

/**
 * @fn void LCD_ShowChinese16x16(u16 x,u16 y,u8 *s,u16 fc,u16 bc,u8 sizey,u8 mode)
 * @brief ʾ16x16
 * @param x xʼ
 * @param y yʼ
 * @param *s Ҫʾĺ
 * @param fc ֵɫ
 * @param bc ֵıɫ
 * @param sizey ֺ
 * @param mode:  0ǵģʽ  1ģʽ
 * @return none
 */
void LCD_ShowChinese16x16(u16 x, u16 y, u8 *s, u16 fc, u16 bc, u8 sizey, u8 mode)
{
	u8 i, j, m = 0;
	u16 k;
	u16 HZnum;//Ŀ
	u16 TypefaceNum;//һַռֽڴС
	u16 x0 = x;

    TypefaceNum = (sizey / 8 + ((sizey % 8) ? 1 : 0)) * sizey;
	HZnum=sizeof(tfont16) / sizeof(typFNT_GB16);	//ͳƺĿ
	for(k = 0; k < HZnum; k++) {
		if ((tfont16[k].Index[0] == *(s)) && (tfont16[k].Index[1] == *(s+1))) { 	
			LCD_Address_Set(SPI1, x, y, x + sizey - 1, y + sizey - 1);
			for(i = 0; i < TypefaceNum; i++) {
				for(j = 0; j < 8; j++) {	
					if(!mode) {//ǵӷʽ
						if(tfont16[k].Msk[i] & (0x01 << j))
						    LCD_WriteHalfWord(SPI1, fc);
						else
						    LCD_WriteHalfWord(SPI1, bc);
						m++;
						if(m%sizey == 0) {
							m = 0;
							break;
						}
					}
					else {//ӷʽ
						if(tfont16[k].Msk[i] & (0x01 << j))
						    LCD_DrawPoint(x, y, fc);//һ
						x++;
						if((x - x0) == sizey) {
							x = x0;
							y++;
							break;
						}
					}
				}
			}
		}				  	
		continue;  //ҵӦֿ˳ֹظȡģӰ
	}
} 

/**
 * @fn oid LCD_ShowChinese24x24(u16 x,u16 y,u8 *s,u16 fc,u16 bc,u8 sizey,u8 mode)
 * @brief ʾ24x24
 * @param x xʼ
 * @param y yʼ
 * @param *s Ҫʾĺ
 * @param fc ֵɫ
 * @param bc ֵıɫ
 * @param sizey ֺ
 * @param mode:  0ǵģʽ  1ģʽ
 * @return none
 */
void LCD_ShowChinese24x24(u16 x, u16 y, u8 *s, u16 fc, u16 bc, u8 sizey, u8 mode)
{
	u8 i, j, m = 0;
	u16 k;
	u16 HZnum;//Ŀ
	u16 TypefaceNum;//һַռֽڴС
	u16 x0 = x;

	TypefaceNum = (sizey / 8 + ((sizey % 8) ? 1 : 0)) * sizey;
	HZnum = sizeof(tfont24) / sizeof(typFNT_GB24);	//ͳƺĿ
	for(k = 0; k < HZnum; k++)
	{
		if ((tfont24[k].Index[0] == *(s)) && (tfont24[k].Index[1] == *(s+1))) { 	
			LCD_Address_Set(SPI1, x, y, x + sizey - 1, y + sizey - 1);
			for(i = 0; i < TypefaceNum; i++) {
				for(j = 0; j < 8; j++) {	
					if(!mode) {//ǵӷʽ
						if(tfont24[k].Msk[i] & (0x01 << j))
						    LCD_WriteHalfWord(SPI1, fc);
						else
						    LCD_WriteHalfWord(SPI1, bc);
						m++;
						if(m % sizey == 0) {
							m = 0;
							break;
						}
					}
					else {//ӷʽ
						if(tfont24[k].Msk[i] & (0x01 << j))
						    LCD_DrawPoint(x, y, fc);//һ
						x++;
						if((x - x0) == sizey) {
							x = x0;
							y++;
							break;
						}
					}
				}
			}
		}				  	
		continue;  //ҵӦֿ˳ֹظȡģӰ
	}
} 

/**
 * @fn void LCD_ShowChinese32x32(u16 x,u16 y,u8 *s,u16 fc,u16 bc,u8 sizey,u8 mode)
 * @brief ʾ32x32
 * @param x xʼ
 * @param y yʼ
 * @param *s Ҫʾĺ
 * @param fc ֵɫ
 * @param bc ֵıɫ
 * @param sizey ֺ
 * @param mode:  0ǵģʽ  1ģʽ
 * @return none
 */
void LCD_ShowChinese32x32(u16 x, u16 y, u8 *s, u16 fc, u16 bc, u8 sizey, u8 mode)
{
	u8 i, j, m = 0;
	u16 k;
	u16 HZnum;//Ŀ
	u16 TypefaceNum;//һַռֽڴС
	u16 x0 = x;
	TypefaceNum=(sizey / 8 + ((sizey % 8) ? 1 : 0)) * sizey;
	HZnum = sizeof(tfont32) / sizeof(typFNT_GB32);	//ͳƺĿ
	for(k = 0; k < HZnum; k++) {
		if ((tfont32[k].Index[0] == *(s))&&(tfont32[k].Index[1] == *(s + 1))) { 	
			LCD_Address_Set(SPI1, x, y, x + sizey - 1, y + sizey - 1);
			for(i = 0; i < TypefaceNum; i++) {
				for(j = 0; j < 8; j++) {	
					if(!mode) {//ǵӷʽ
						if(tfont32[k].Msk[i] & (0x01 << j))
						    LCD_WriteHalfWord(SPI1, fc);
						else
						    LCD_WriteHalfWord(SPI1, bc);
						m++;
						if(m%sizey == 0) {
							m = 0;
							break;
						}
					}
					else {//ӷʽ
						if(tfont32[k].Msk[i] & (0x01 << j))
						    LCD_DrawPoint(x, y, fc);//һ
						x++;
						if((x - x0) == sizey) {
							x = x0;
							y++;
							break;
						}
					}
				}
			}
		}				  	
		continue;  //ҵӦֿ˳ֹظȡģӰ
	}
}

/**
 * @fn void LCD_ShowChar(u16 x,u16 y,u8 num,u16 fc,u16 bc,u8 sizey,u8 mode)
 * @brief ʾַ
 * @param x xʼ
 * @param y yʼ
 * @param num Ҫʾַ ascii
 * @param fc ֵɫ
 * @param bc ֵıɫ
 * @param sizey ֺ
 * @param mode:  0ǵģʽ  1ģʽ
 * @return none
 */
void LCD_ShowChar(u16 x, u16 y, u8 num, u16 fc, u16 bc, u8 sizey, u8 mode)
{
	u8 temp, sizex, t, m = 0;
	u16 i, TypefaceNum;//һַռֽڴС
	u16 x0 = x;

	sizex = sizey/2;
	TypefaceNum = (sizex / 8 + ((sizex % 8) ? 1 : 0)) * sizey;
	num = num - ' ';    //õƫƺֵ
	LCD_Address_Set(SPI1, x, y, x + sizex - 1, y + sizey - 1);  //ùλ
	for(i = 0; i < TypefaceNum; i++) { 
		if(sizey == 12)
		    temp = ascii_1206[num][i];		       //6x12
		else if(sizey == 16)
		    temp = ascii_1608[num][i];		 //8x16
		else if(sizey == 24)
		    temp = ascii_2412[num][i];		 //12x24
		else if(sizey == 32)
		    temp = ascii_3216[num][i];		 //16x32
//		else if(sizey == 64)
//		    temp = sz32[num][i];//
		else return;
		for(t=0;t<8;t++) {
			if(!mode) {//ǵģʽ
				if(temp&(0x01<<t))
				    LCD_WriteHalfWord(SPI1, fc);
				else
				    LCD_WriteHalfWord(SPI1, bc);
				m++;
				if(m%sizex==0) {
					m=0;
					break;
				}
			}
			else {//ģʽ
				if(temp&(0x01 << t))
				    LCD_DrawPoint(x, y, fc);//һ
				x++;
				if((x - x0) == sizex) {
					x = x0;
					y++;
					break;
				}
			}
		}
	}   	 	  
}

/**
 * @fn void LCD_ShowString(u16 x,u16 y,const u8 *p,u16 fc,u16 bc,u8 sizey,u8 mode)
 * @brief ʾַ
 * @param x xʼ
 * @param y yʼ
 * @param *p Ҫʾַ
 * @param fc ֵɫ
 * @param bc ֵıɫ
 * @param sizey ֺ
 * @param mode:  0ǵģʽ  1ģʽ
 * @return none
 */
void LCD_ShowString(u16 x, u16 y, const u8 *p, u16 fc, u16 bc, u8 sizey, u8 mode)
{         
	while(*p != '\0') {       
		LCD_ShowChar(x, y, *p, fc, bc, sizey, mode);
		x += sizey / 2;
		p++;
	}  
}

/**
 * @fn u32 mypow(u8 m,u8 n)
 * @brief ʾ
 * @param m 
 * @param n ָ
 * @return none
 */
u32 mypow(u8 m, u8 n)
{
	u32 result = 1;
	while(n--)
	    result *= m;
	return result;
}

/**
 * @fn void LCD_ShowIntNum(u16 x,u16 y,u16 num,u8 len,u16 fc,u16 bc,u8 sizey)
 * @brief ʾ
 * @param x xʼ
 * @param y yʼ
 * @param num Ҫʾ
 * @param len Ҫʾλ
 * @param fc ֵɫ
 * @param sizey ֺ
 * @return none
 */
void LCD_ShowIntNum(u16 x, u16 y, u16 num, u8 len, u16 fc, u16 bc, u8 sizey)
{         	
	u8 t, temp;
	u8 enshow = 0;
	u8 sizex = sizey / 2;

	for(t = 0; t < len; t++) {
		temp = (num / mypow(10, len - t - 1)) % 10;
		if(enshow == 0 && t < (len - 1)) {
			if(temp == 0) {
				LCD_ShowChar(x + t * sizex, y, ' ', fc, bc, sizey, 0);
				continue;
			}else
			    enshow = 1;
		 	 
		}
	 	LCD_ShowChar(x + t * sizex, y, temp + 48, fc, bc, sizey, 0);
	}
} 

/**
 * @fn void LCD_ShowFloatNum1(u16 x,u16 y,float num,u8 len,u16 fc,u16 bc,u8 sizey)
 * @brief ʾλС
 * @param x xʼ
 * @param y yʼ
 * @param num ҪʾС
 * @param len Ҫʾλ
 * @param fc ֵɫ
 * @param bc ֵıɫ
 * @param sizey ֺ
 * @return none
 */
void LCD_ShowFloatNum1(u16 x, u16 y, float num, u8 len, u16 fc, u16 bc, u8 sizey)
{         	
	u8 t, temp, sizex;
	u16 num1;

	sizex = sizey/2;
	num1 = num*100;
	for(t = 0; t < len; t++) {
		temp = (num1 / mypow(10, len - t - 1)) % 10;
		if(t == (len - 2)) {
			LCD_ShowChar(x + (len - 2) * sizex, y, '.' , fc, bc, sizey, 0);
			t++;
			len += 1;
		}
	 	LCD_ShowChar(x + t * sizex, y, temp + 48, fc, bc, sizey, 0);
	}
}

/**
 * @fn void LCD_ShowFloatNum2(u16 x,u16 y,float num,u8 len,u16 fc,u16 bc,u8 sizey)
 * @brief ʾһλС
 * @param x xʼ
 * @param y yʼ
 * @param num ҪʾС
 * @param len Ҫʾλ
 * @param fc ֵɫ
 * @param bc ֵıɫ
 * @param sizey ֺ
 * @return none
 */
void LCD_ShowFloatNum2(u16 x, u16 y, float num, u8 len, u16 fc, u16 bc, u8 sizey)
{         	
	u8 t, temp, sizex;
	u16 num1;

	sizex = sizey / 2;
	num1 = num * 10;
	for(t = 0; t < len; t++) {
		temp = (num1 / mypow(10, len - t - 1)) % 10;
		if(t == (len - 1)) {
			LCD_ShowChar(x + (len - 1) * sizex, y, '.', fc, bc, sizey, 0);
			t ++;
			len += 1;
		}
	 	LCD_ShowChar(x + t * sizex, y, temp + 48, fc, bc, sizey, 0);
	}
}

/**
 * @fn void LCD_ShowPicture(u16 x, u16 y, u16 length, u16 width, const unsigned char *p)
 * @brief ʾͼƬ
 * @param x xʼ
 * @param y yʼ
 * @param lenth ͼƬ
 * @param width ͼƬ
 * @param *p ͼƬ
 * @return none
 */
void LCD_ShowPicture(u16 x, u16 y, u16 width, u16 High, const unsigned char *p)
{
    u32 i;
//  u16 num;
    unsigned char picH, picL;

//    num=length*width*2;
    LCD_Address_Set(SPI1, x, y, x + width, High - y);
    for(i = 0; i < width * (High - y + 1); i++) {
        picL = *(p + i * 2);  //ݵλǰ
        picH = *(p + i * 2 + 1);
        LCD_WriteHalfWord(SPI1, picH << 8 | picL);
    }
}

/**
 * @fn void LCD_ShowPicture(u16 x, u16 y, u16 length, u16 width, const unsigned char *p)
 * @brief ʾͼƬ
 * @param x xʼ
 * @param y yʼ
 * @param lenth ͼƬ
 * @param width ͼƬ
 * @param *p ͼƬ
 * @return none
 */
void LCD_ShowPicture_DMA(u16 x, u16 y, u16 width, u16 High, u16 num, u8 *p)
{
//    u32 i;

    // num = High * width * 2;

    LCD_Address_Set(SPI1, x, y, x + width, High - y);

//    for(i = 0; i < num; i++) {//
        //
//        TxData[i * 2 + 1] = *(p + i * 2);
//        TxData[i * 2] = *(p + i * 2 + 1);
        //С
//        TxData[i] = *p;
//        p ++;
//    }

    LCD_WriteData_Batch(SPI1, p, num);
}
