#ifndef __LCD_H
#define __LCD_H

#include "debug.h"

//画笔颜色
#define WHITE            0xFFFF//白色
#define BLACK            0x0000//黑色
#define LIGHTPINK        0xFDB8//浅粉红
#define PINK             0xFE19//粉红
#define SCARLET          0xd8a7//猩红
#define BLUE             0x001F//蓝色
#define BRED             0XF81F//紫红色
#define GBLUE            0X07FF//青色
#define RED              0xF800//红色
#define MAGENTA          0xF81F//品红
#define GREEN            0x07E0//绿色
#define YELLOW           0xFFE0//黄色
#define BROWN            0XBC40 //棕色
#define BRRED            0XFC07 //棕红色
#define GRAY             0X8430 //灰色
#define GRAY0            0xEF7D //灰色0 31650011000101100101
#define GRAY1            0x8410 //灰色1 0000000000000000
#define GRAY2            0x4208 //灰色2 1111111111011111
#define DARKBLUE         0X01CF //深蓝色
#define LIGHTBLUE        0X7D7C //浅蓝色
#define GRAYBLUE         0X5458 //灰蓝色
#define LIGHTGREEN       0X841F //浅绿色
#define LGRAY            0XC618 //浅灰色(PANNEL),窗体背景色
#define LGRAYBLUE        0XA651 //浅灰蓝色(中间层颜色)
#define LBBLUE           0X2B12 //浅棕蓝色(选择条目的反色)

void LCD_Fill(uint16_t xsta, uint16_t ysta, uint16_t xend, uint16_t yend, uint16_t color);//指定区域填充颜色
void LCD_SetXY(u16 x, u16 y);
void LCD_DrawPoint(u16 x, u16 y, u16 color);//在指定位置画一个点
void LCD_DrawLine(u16 x1, u16 y1, u16 x2, u16 y2, u16 color);//在指定位置画一条线
void DisplayButtonDown(u16 x1, u16 y1, u16 x2, u16 y2);
void DisplayButtonUp(u16 x1, u16 y1, u16 x2, u16 y2);
void LCD_DrawRectangle(u16 x1, u16 y1, u16 x2, u16 y2,u16 color);//在指定位置画一个矩形
void Draw_Circle(u16 x0,u16 y0,u8 r,u16 color);//在指定位置画一个圆

void LCD_ShowChinese(u16 x, u16 y, u8 *s, u16 fc, u16 bc, u8 sizey, u8 mode);//显示汉字串
void LCD_ShowChinese12x12(u16 x, u16 y, u8 *s, u16 fc, u16 bc, u8 sizey, u8 mode);//显示单个12x12汉字
void LCD_ShowChinese16x16(u16 x, u16 y, u8 *s, u16 fc, u16 bc, u8 sizey, u8 mode);//显示单个16x16汉字
void LCD_ShowChinese24x24(u16 x, u16 y, u8 *s, u16 fc, u16 bc, u8 sizey, u8 mode);//显示单个24x24汉字
void LCD_ShowChinese32x32(u16 x, u16 y, u8 *s, u16 fc, u16 bc, u8 sizey, u8 mode);//显示单个32x32汉字

void LCD_ShowChar(u16 x, u16 y, u8 num, u16 fc, u16 bc, u8 sizey, u8 mode);//显示一个字符
void LCD_ShowString(u16 x, u16 y, const u8 *p, u16 fc, u16 bc, u8 sizey, u8 mode);//显示字符串
u32 mypow(u8 m, u8 n);//求幂
void LCD_ShowIntNum(u16 x, u16 y, u16 num, u8 len, u16 fc, u16 bc, u8 sizey);//显示整数变量
void LCD_ShowFloatNum1(u16 x, u16 y, float num, u8 len, u16 fc, u16 bc, u8 sizey);//显示两位小数变量
void LCD_ShowFloatNum2(u16 x, u16 y, float num, u8 len, u16 fc, u16 bc, u8 sizey);//显示一位小数变量

void LCD_ShowPicture(u16 x, u16 y, u16 length, u16 width, const u8 pic[]);//显示图片
void LCD_ShowPicture_DMA(u16 x, u16 y, u16 width, u16 High, u16 num, unsigned char *p);
//void LCD_ShowPicture_Col(u16 y, u16 width, const unsigned char *p);//按行显示图片
#endif
