#include "lcd_init.h"
#include "debug.h"
#include "spi.h"
//#include "dma.h"
#include "stdint.h"
//#include "w25qxx.h"

// extern u8 TxData[];
// extern u8 Test_RX[];
__IO uint8_t ID[4] = {0};

/**
 * @fn void LCD_WriteIndex(u8 Index)
 * @brief LCDд
 * @param index д
 * @return
*/
void LCD_WriteIndex(SPI_TypeDef* SPIx, u8 Index)
{
    LCD_CS_CLR;
    LCD_DC_CLR;
    SPI_LCD_WriteByte(SPIx,Index);
    LCD_CS_SET;
}

/**
 * @fn void LCD_WriteData(u8 Data)
 * @brief LCDдһֽ
 * @param dat д
 * @return none
*/
void LCD_WriteData(SPI_TypeDef* SPIx, u8 Data)
{
//    W25Q_CS_SET;
    LCD_CS_CLR;
    LCD_DC_SET;
    SPI_LCD_WriteByte(SPIx,Data);
    LCD_CS_SET;
}

/**
 * @fn void LCD_WriteHalfWord(u16 Data)
 * @brief LCDдֽ
 * @param Data
 * @return none
*/
void LCD_WriteHalfWord(SPI_TypeDef* SPIx, u16 Data)
{
//    W25Q_CS_SET;
    LCD_CS_CLR;
    LCD_DC_SET;
    SPI_LCD_WriteHalfWord(SPIx,Data);
    LCD_CS_SET;
}

/**
 * @fn void LCD_WriteHalfWord(u16 Data)
 * @brief LCDдֽ
 * @param Data
 * @return none
*/
void LCD_WriteData_Batch(SPI_TypeDef* SPIx, u8 *p, u16 num)
{
//    W25Q_CS_SET;
    LCD_CS_CLR;
    LCD_DC_SET;
    SPI_LCD_Write_Batch(SPIx, p, num);
    LCD_CS_SET;
}


/**
 * @fn void LCD_WriteReg(u8 Index,u16 Data)
 * @brief дĴ,IndexַļĴдDataֵ
 * @param Index
 * @paran Data
 * @return none
 */
void LCD_WriteReg(u8 Index,u16 Data)
{
    LCD_WriteIndex(SPI1, Index);
    LCD_WriteHalfWord(SPI1, Data);
}

/**
 * @fn void LCD_Reset(void)
 * @brief Һʼǰִһθλ
 * @param none
 * @return none
*/
void LCD_Reset(void)
{
    LCD_RESET_CLR;
    Delay_Ms(100);
    LCD_RESET_SET;
    Delay_Ms(50);
}

/**
 * @filename Lcd_Read_ID ȡLCDоƬID
 * @param None
 * @return None
 */
void Lcd_Read_ID(void)
{
    uint8_t i;

    LCD_DC_CLR;
    LCD_CS_CLR;
    LCD_WriteIndex(SPI1, 0x04);
    SPI1->CTLR1 |= 1 << 15;//˫
    SPI1->CTLR1 &= ~(1<<14);//MOSIлΪ״̬
    LCD_DC_SET;
    SPI_I2S_DMACmd(SPI1, SPI_I2S_DMAReq_Rx, ENABLE);//ʹSPIյDMA
    DMA_Cmd(DMA1_Channel4, ENABLE);
    while(DMA_GetFlagStatus(DMA1_FLAG_TC4) == 0);//DMAȴ
    SPI_I2S_DMACmd(SPI1, SPI_I2S_DMAReq_Rx, DISABLE); //رSPIյDMA
    DMA_Cmd(DMA1_Channel4, DISABLE);
    DMA_ClearFlag(DMA1_FLAG_TC4);//־
    LCD_CS_SET;

    for(i = 0; i < 4; i ++) {
        printf("ID%d:0x%02x; ", i, ID[i]);
    }
    printf("\n");
    SPI1->CTLR1 |= (1<<14);//MOSIлΪ״̬
}

/**
 * @fn void LCD_Address_Set(u16 x1,u16 y1,u16 x2,u16 y2)
 * @brief ʼͽַ
 * @param x1 ʼַ
 * @param y1 ʼַ
 * @param x2 нַ
 * @param y2 нַ
 * @return none
*/
void LCD_Address_Set(SPI_TypeDef* SPIx, u16 x1,u16 y1,u16 x2,u16 y2)
{
#if ST7735S
    #if(USE_HORIZONTAL == 0)
	{
		LCD_WriteIndex(SPIx, 0x2a);//еַ
		LCD_WriteHalfWord(SPIx, x1+2);
		LCD_WriteHalfWord(SPIx, x2+2);
		LCD_WriteIndex(SPIx, 0x2b);//еַ
		LCD_WriteHalfWord(SPIx, y1+1);
		LCD_WriteHalfWord(SPIx, y2+1);
		LCD_WriteIndex(SPIx, 0x2c);//д
	}
    #elif(USE_HORIZONTAL == 1)
	{
		LCD_WriteIndex(SPIx, 0x2a);//еַ
		LCD_WriteHalfWord(SPIx, x1+2);
		LCD_WriteHalfWord(SPIx, x2+2);
		LCD_WriteIndex(SPIx, 0x2b);//еַ
		LCD_WriteHalfWord(SPIx, y1+1);
		LCD_WriteHalfWord(SPIx, y2+1);
		LCD_WriteIndex(SPIx, 0x2c);//д
	}
    #elif(USE_HORIZONTAL == 2)
	{
		LCD_WriteIndex(SPIx, 0x2a);//еַ
		LCD_WriteHalfWord(SPIx, x1+1);
		LCD_WriteHalfWord(SPIx, x2+1);
		LCD_WriteIndex(SPIx, 0x2b);//еַ
		LCD_WriteHalfWord(SPIx, y1+2);
		LCD_WriteHalfWord(SPIx, y2+2);
		LCD_WriteIndex(SPIx, 0x2c);//д
	}
    #elif(USE_HORIZONTAL == 3)
	{
		LCD_WriteIndex(SPIx, 0x2a);//еַ
		LCD_WriteHalfWord(SPIx, x1+1);
		LCD_WriteHalfWord(SPIx, x2+1);
		LCD_WriteIndex(SPIx, 0x2b);//еַ
		LCD_WriteHalfWord(SPIx, y1+2);
		LCD_WriteHalfWord(SPIx y2+2);
		LCD_WriteIndex(SPIx, 0x2c);//д
	}
    #endif
#elif ST7789
    #if (USE_HORIZONTAL == 0)
    {
        LCD_WriteIndex(SPIx, 0x2a);//еַ
        LCD_WriteHalfWord(SPIx, x1);
        LCD_WriteHalfWord(SPIx, x2);
//        LCD_WriteHalfWord(SPIx, x2-1);//ͼƬбʱ
        LCD_WriteIndex(SPIx, 0x2b);//еַ
        LCD_WriteHalfWord(SPIx, y1);
        LCD_WriteHalfWord(SPIx, y2);
        LCD_WriteIndex(SPIx, 0x2c);//д
    }
    #elif (USE_HORIZONTAL == 1)
    {
        LCD_WriteIndex(SPIx, 0x2a);//еַ
        LCD_WriteHalfWord(SPIx, x1);
        LCD_WriteHalfWord(SPIx, x2);
        LCD_WriteIndex(SPIx, 0x2b);//еַ
        LCD_WriteHalfWord(SPIx, y1);
        LCD_WriteHalfWord(SPIx, y2);
        LCD_WriteIndex(SPIx, 0x2c);//д
    }
    #elif(USE_HORIZONTAL == 2)
    {
        LCD_WriteIndex(SPIx, 0x2a);//еַ
        LCD_WriteHalfWord(SPIx, x1);
        LCD_WriteHalfWord(SPIx, x2);
        LCD_WriteIndex(SPIx, 0x2b);//еַ
        LCD_WriteHalfWord(SPIx, y1);
        LCD_WriteHalfWord(SPIx, y2);
        LCD_WriteIndex(SPIx, 0x2c);//д
    }
    #elif (USE_HORIZONTAL == 3)
    {
        LCD_WriteIndex(SPIx, 0x2a);//еַ
        LCD_WriteHalfWord(SPIx, x1);
        LCD_WriteHalfWord(SPIx, x2);
        LCD_WriteIndex(SPIx, 0x2b);//еַ
        LCD_WriteHalfWord(SPIx, y1);
        LCD_WriteHalfWord(SPIx, y2);
        LCD_WriteIndex(SPIx, 0x2c);//д
    }
    #endif
#endif
}

/**
 * @fn void LCD_Init(void)
 * @brief оƬʼ
 * @param none
 * @return none
 */
void LCD_Init(SPI_TypeDef* SPIx)
{
    uint8_t lcd_data = 0;
    
    SPI1_Flash_Init();
//    SPI2_Init();
    LCD_Reset(); //Reset before LCD Init.

//     Lcd_Read_ID();

//     LCD_Reset(); //Reset before LCD Init.

	// //************* Start Initial Sequence **********//
    LCD_WriteIndex(SPIx, 0x11);//Sleep exit
    Delay_Ms(120);
	
#if ST7735S
	//-------ST7735S Frame Rate----------------//
	LCD_WriteIndex(SPIx, 0xB1);
	LCD_WriteData(SPIx, 0x01);// LCD_WriteData(0x05);
	LCD_WriteData(SPIx, 0x2C); // LCD_WriteData(0x3C);
	LCD_WriteData(SPIx, 0x2D); // LCD_WriteData(0x3C);

	LCD_WriteIndex(SPIx, 0xB2);
	LCD_WriteData(SPIx, 0x01);// LCD_WriteData(0x05);
	LCD_WriteData(SPIx, 0x2C);// LCD_WriteData(0x3C);
	LCD_WriteData(SPIx, 0x2D);// LCD_WriteData(0x3C);

	LCD_WriteIndex(SPIx, 0xB3);
	LCD_WriteData(SPIx, 0x01);// LCD_WriteData(0x05);
	LCD_WriteData(SPIx, 0x2C);// LCD_WriteData(0x3C);
	LCD_WriteData(SPIx, 0x2D);// LCD_WriteData(0x3C);
	LCD_WriteData(SPIx, 0x01);// LCD_WriteData(0x05);
	LCD_WriteData(SPIx, 0x2C);// LCD_WriteData(0x3C);
	LCD_WriteData(SPIx, 0x2D);// LCD_WriteData(0x3C);

	//------------------------------------End ST7735S Frame Rate---------------------------------// 
	LCD_WriteIndex(SPIx, 0xB4); //Dot inversion
	LCD_WriteData(SPIx, 0x07);
	//------------------------------------ST7735S Power Sequence---------------------------------// 
	LCD_WriteIndex(SPIx, 0xC0);
	LCD_WriteData(SPIx, 0xA2);// LCD_WriteData(0x28);
	LCD_WriteData(SPIx, 0x02);// LCD_WriteData(0x08);
	LCD_WriteData(SPIx, 0x84);// LCD_WriteData(0x04);

	LCD_WriteIndex(SPIx, 0xC1);
	LCD_WriteData(SPIx, 0XC5);// LCD_WriteData(0XC0);

	LCD_WriteIndex(SPIx, 0xC2);
	LCD_WriteData(SPIx, 0x0A);// LCD_WriteData(0x0D);
	LCD_WriteData(SPIx, 0x00);// LCD_WriteData(0x00);

	LCD_WriteIndex(SPIx, 0xC3);
	LCD_WriteData(SPIx, 0x8A);// LCD_WriteData(0x8D);
	LCD_WriteData(SPIx, 0x2A);// LCD_WriteData(0x2A);

	LCD_WriteIndex(SPIx, 0xC4);
	LCD_WriteData(SPIx, 0x8A);// LCD_WriteData(0x8D);
	LCD_WriteData(SPIx, 0xEE);// LCD_WriteData(0xEE);
	//---------------------------------End ST7735S Power Sequence-------------------------------------// 
	LCD_WriteIndex(SPIx, 0xC5); //VCOM
	LCD_WriteData(SPIx, 0x0E);// LCD_WriteData(0x1A);

	LCD_WriteIndex(SPIx, 0x36); //MX, MY, RGB mode
    #if(USE_HORIZONTAL==0)
		LCD_WriteData(SPIx, 0x00);
    #elif(USE_HORIZONTAL==1)
		LCD_WriteData(SPIx, 0xC0);
    #elif(USE_HORIZONTAL==2)
		LCD_WriteData(SPIx, 0x70);
    #elif(USE_HORIZONTAL==3)
		LCD_WriteData(SPIx, 0xA0);
    #endif
	//------------------------------------ST7735S Gamma Sequence---------------------------------// 
	LCD_WriteIndex(SPIx, 0xE0);
	LCD_WriteData(SPIx, 0x0f);// LCD_WriteData(0x04);
	LCD_WriteData(SPIx, 0x1a);// LCD_WriteData(0x22);
	LCD_WriteData(SPIx, 0x0f);// LCD_WriteData(0x07);
	LCD_WriteData(SPIx, 0x18);// LCD_WriteData(0x0A);
	LCD_WriteData(SPIx, 0x2f);// LCD_WriteData(0x2E);
	LCD_WriteData(SPIx, 0x28);// LCD_WriteData(0x30);
	LCD_WriteData(SPIx, 0x20);// LCD_WriteData(0x25);
	LCD_WriteData(SPIx, 0x22);// LCD_WriteData(0x2A);
	LCD_WriteData(SPIx, 0x1f);// LCD_WriteData(0x28);
	LCD_WriteData(SPIx, 0x1b);// LCD_WriteData(0x26);
	LCD_WriteData(SPIx, 0x23);// LCD_WriteData(0x2E);
	LCD_WriteData(SPIx, 0x37);// LCD_WriteData(0x3A);
	LCD_WriteData(SPIx, 0x00);// LCD_WriteData(0x00);
	LCD_WriteData(SPIx, 0x07);// LCD_WriteData(0x01);
	LCD_WriteData(SPIx, 0x02);// LCD_WriteData(0x03);
	LCD_WriteData(SPIx, 0x10);// LCD_WriteData(0x13);

	LCD_WriteIndex(SPIx, 0xE1);
	LCD_WriteData(SPIx, 0x0f);// LCD_WriteData(0x04);
	LCD_WriteData(SPIx, 0x1b);// LCD_WriteData(0x16);
	LCD_WriteData(SPIx, 0x0f);// LCD_WriteData(0x06);
	LCD_WriteData(SPIx, 0x17);// LCD_WriteData(0x0D);
	LCD_WriteData(SPIx, 0x33);// LCD_WriteData(0x2D);
	LCD_WriteData(SPIx, 0x2c);// LCD_WriteData(0x26);
	LCD_WriteData(SPIx, 0x29);// LCD_WriteData(0x23);
	LCD_WriteData(SPIx, 0x2e);// LCD_WriteData(0x27);
	LCD_WriteData(SPIx, 0x30);// LCD_WriteData(0x27);
	LCD_WriteData(SPIx, 0x30);// LCD_WriteData(0x25);
	LCD_WriteData(SPIx, 0x39);// LCD_WriteData(0x2D);
	LCD_WriteData(SPIx, 0x3f);// LCD_WriteData(0x3B);
	LCD_WriteData(SPIx, 0x00);// LCD_WriteData(0x00);
	LCD_WriteData(SPIx, 0x07);// LCD_WriteData(0x01);
	LCD_WriteData(SPIx, 0x03);// LCD_WriteData(0x04);
	LCD_WriteData(SPIx, 0x10);// LCD_WriteData(0x13);

	LCD_WriteIndex(SPIx, 0x2a);
	LCD_WriteData(SPIx, 0x00);
	LCD_WriteData(SPIx, 0x00);
	LCD_WriteData(SPIx, 0x00);
	LCD_WriteData(SPIx, 0x7f);

	LCD_WriteIndex(SPIx, 0x2b);
	LCD_WriteData(SPIx, 0x00);
	LCD_WriteData(SPIx, 0x00);
	LCD_WriteData(SPIx, 0x00);
	LCD_WriteData(SPIx, 0x9f);

    LCD_WriteIndex(SPIx, 0xF0); //Enable test command
    LCD_WriteData(SPIx, 0x01);//LCD_WriteIndex
    LCD_WriteIndex(SPIx, 0xF6); //Disable ram power save mode
    LCD_WriteData(SPIx, 0x00);
	//------------------------------------End ST7735S Gamma Sequence-----------------------------// 
	LCD_WriteIndex(SPIx, 0x3A); //65k mode
	LCD_WriteData(SPIx, 0x05);
	LCD_WriteIndex(SPIx, 0x29); //Display on

#elif ST7789
    //************* Start Initial Sequence **********//
    LCD_WriteIndex(SPIx, 0x36);
    #if DISPLAY_BOTTOM_TO_TOP
        lcd_data |= (1<<7);
    #else
        lcd_data |= (0<<7);
    #endif
    #if DISPLAY_RIGHT_TO_LEFT 
        lcd_data |= (1<<6);
    #else
        lcd_data |= (0<<6);
    #endif

    #if DISPLAY_OVERTURN//תʾ
        lcd_data |= (1<<5);//תʾ
    #else
        lcd_data |= (0<<5);
    #endif
        LCD_WriteData(SPIx, lcd_data);

        LCD_WriteIndex(SPIx, 0x3A);
        LCD_WriteData(SPIx, 0x05);//RGB565

        //Porch setting
        LCD_WriteIndex(SPIx, 0xB2);
        LCD_WriteData(SPIx, 0x0C);
        LCD_WriteData(SPIx, 0x0C);
        LCD_WriteData(SPIx, 0x00);
        LCD_WriteData(SPIx, 0x33);
        LCD_WriteData(SPIx, 0x33);

        //Gate setiing
        LCD_WriteIndex(SPIx, 0xB7);
        LCD_WriteData(SPIx, 0x35);

        //VCOM SETTING
        // LCD_WriteIndex(SPIx, 0xBB);
        // LCD_WriteData(SPIx, 0x32); //Vcom=1.35V
        LCD_WriteIndex(SPIx, 0xBB);
        LCD_WriteData(SPIx, 0x19); //Vcom=1.35V

        //LCM Control
        LCD_WriteIndex(SPIx, 0xC0);
        LCD_WriteData(SPIx, 0x2C);

        //VDV and VRH Command Enable
        LCD_WriteIndex(SPIx, 0xC2);
        LCD_WriteData(SPIx, 0x01);

        //VRH setting
        // LCD_WriteIndex(SPIx, 0xC3);
        // LCD_WriteData(SPIx, 0x15); //GVDD=4.8V  ɫ
        LCD_WriteIndex(SPIx, 0xC3);
        LCD_WriteData(SPIx, 0x12); //GVDD=4.8V  ɫ

        //VDV setting
        LCD_WriteIndex(SPIx, 0xC4);
        LCD_WriteData(SPIx, 0x20); //VDV, 0x20:0v

        //Frame Rate Control in Normal mode
        LCD_WriteIndex(SPIx, 0xC6);
        LCD_WriteData(SPIx, 0x0F); //0x0F:60Hz

        //Power Control
        LCD_WriteIndex(SPIx, 0xD0);
        LCD_WriteData(SPIx, 0xA4);
        LCD_WriteData(SPIx, 0xA1);

        //Positive Voltage Gamma Control
        // LCD_WriteIndex(SPIx, 0xE0);
        // LCD_WriteData(SPIx, 0xD0);
        // LCD_WriteData(SPIx, 0x08);
        // LCD_WriteData(SPIx, 0x0E);
        // LCD_WriteData(SPIx, 0x09);
        // LCD_WriteData(SPIx, 0x09);
        // LCD_WriteData(SPIx, 0x05);
        // LCD_WriteData(SPIx, 0x31);
        // LCD_WriteData(SPIx, 0x33);
        // LCD_WriteData(SPIx, 0x48);
        // LCD_WriteData(SPIx, 0x17);
        // LCD_WriteData(SPIx, 0x14);
        // LCD_WriteData(SPIx, 0x15);
        // LCD_WriteData(SPIx, 0x31);
        // LCD_WriteData(SPIx, 0x34);
        LCD_WriteIndex(SPIx, 0xE0);
        LCD_WriteData(SPIx, 0xD0);
        LCD_WriteData(SPIx, 0x04);
        LCD_WriteData(SPIx, 0x0D);
        LCD_WriteData(SPIx, 0x11);
        LCD_WriteData(SPIx, 0x13);
        LCD_WriteData(SPIx, 0x2B);
        LCD_WriteData(SPIx, 0x3F);
        LCD_WriteData(SPIx, 0x54);
        LCD_WriteData(SPIx, 0x4C);
        LCD_WriteData(SPIx, 0x18);
        LCD_WriteData(SPIx, 0x0D);
        LCD_WriteData(SPIx, 0x0B);
        LCD_WriteData(SPIx, 0x1F);
        LCD_WriteData(SPIx, 0x23);

        //Negative Voltage Gamma Control
        // LCD_WriteIndex(SPIx, 0xE1);
        // LCD_WriteData(SPIx, 0xD0);
        // LCD_WriteData(SPIx, 0x08);
        // LCD_WriteData(SPIx, 0x0E);
        // LCD_WriteData(SPIx, 0x09);
        // LCD_WriteData(SPIx, 0x09);
        // LCD_WriteData(SPIx, 0x15);
        // LCD_WriteData(SPIx, 0x31);
        // LCD_WriteData(SPIx, 0x33);
        // LCD_WriteData(SPIx, 0x48);
        // LCD_WriteData(SPIx, 0x17);
        // LCD_WriteData(SPIx, 0x14);
        // LCD_WriteData(SPIx, 0x15);
        // LCD_WriteData(SPIx, 0x31);
        // LCD_WriteData(SPIx, 0x34);
        LCD_WriteIndex(SPIx, 0xE1);
        LCD_WriteData(SPIx, 0xD0);
        LCD_WriteData(SPIx, 0x04);
        LCD_WriteData(SPIx, 0x0C);
        LCD_WriteData(SPIx, 0x11);
        LCD_WriteData(SPIx, 0x13);
        LCD_WriteData(SPIx, 0x2C);
        LCD_WriteData(SPIx, 0x3F);
        LCD_WriteData(SPIx, 0x44);
        LCD_WriteData(SPIx, 0x51);
        LCD_WriteData(SPIx, 0x2F);
        LCD_WriteData(SPIx, 0x1F);
        LCD_WriteData(SPIx, 0x1F);
        LCD_WriteData(SPIx, 0x20);
        LCD_WriteData(SPIx, 0x23);

        //Display Inversion On
        LCD_WriteIndex(SPIx, 0x21);

        //Display on
        LCD_WriteIndex(SPIx, 0x29);
#endif
}
